/*
** file: isll.h
**
** Integer Single Linked List
** UC: 21046 - EDAF @ UAb
** e-fólio A 2022-23
**
** Aluno: 2000809 - Pedro Santos
*/


// Defina:
// em file.h as classes da estrutura de dados
// em file.cpp a implementação dos métodos das classes da estrutura de dados

// definir nó
struct INode {
   // atributos obrigatórios
   int item;             // informação em cada nó
   // outros atributos e métodos (protótipos) livres
   
   INode();
   ~INode();
   
   INode *next;
};

// definir lista simplesmente ligada
class ISll {
private:
   // atributos obrigatórios
   int n;                // dimensão atual da lista
   // outros atributos e métodos (protótipos) livres
   INode *head;
   INode *tail;
   
   
   
public:
   ISll();
   ~ISll();
   
   int getn();//devolve o valor de n
   int isEmpty(); // verifica se a lista está vazia
   
   void insert_0(int); //Insere no inicio o item 
   void insert_end(int);//Insere no fim
   
   void print_0(); //imprime 1º item "Lista(0)= %d\n"
   void print_end();//imprime ultimo item "Lista(end)= %d\n"
   void print();//imprime toda a lista "Lista= %d %d ...\n"
   
   
   void delete_0();//remove 1º no
   void delete_end();//remove ultimo no
   void delete_pos(int);//remove posição x (pos 0 = 1ª)
   void clear();//remove todos os nos
   
   void dim();//imprime nro de items na lista "Lista tem %d itens\n"
   
   void find(int);//Imprime a posição da 1ª ocurrencia do item - "Item %d na posicao %d\n" ou "Item %d nao encontrado!\n"
   void find_max();//Imprime a primeira ocorrência do maior item na lista e imprime a sua posição "Max Item %d na posicao %d\n"
   
   void invert_range(int,int);//Inverte a ordem entre pos1 e pos2 (criar lista aux, remover e reinserir os intems em causa)
   
};

// EOF

