/*
** file: main-isll.cpp
**
** Integer Single Linked List
** UC: 21046 - EDAF @ UAb
** e-fólio A 2022-23
**
** Aluno: 2000809 - Pedro Santos
*/

// Defina neste ficheiro:
//   A entrada/saída de dados
//   As instâncias da classe da estrutura de dados
//   A implementação dos comandos através dos métodos da classe
//   Código auxiliar
//   Não utilize variáveis globais

#include <iostream>
#include <sstream>
#include "isll.h"
using namespace std;


int main()
{
   ISll list;   // exemplo
   std::string input,command; //string de recepcao de input e recepcao do comando
   int arg1,arg2; // argumentos a usar nas funcoes
   stringstream ss; 

//Ler 1 linha, Processar 1 linha (while !EOF) Sugerencia de ler para uma string e analisar se o primeiro caracter é # ou nao. Se não for
//Criar uma stringstream e usar >> para obter o nome do comando. Se for linha em branco, falha. (Salta espaços, tabs e new lines antes de efetuar uma leitura)


    while(getline(cin,input)){ /*Utiliza-se a condição de se a leitura foi bem sucessida para fazer um loop para ler todo o input*/
    
    if(input[0]!='#'&&!input.empty())/*Verifica-se se o primeiro caracter é # ou se é uma linha em branco, continuado o programa em caso negativo*/
    {
        ss << input; /*passa-se o input para a string stream*/
        ss >> command; /* passa-se apenas o comando com o uso de >> para a var. que guarda o comando*/
    
    
/*Para todos os comandos, compara-se a string guardada na var command com a palavra que interpreta o comando, executando-o caso sejam iguais*/
        if(!command.compare("insert_0")){
            while(ss>>arg1) /* caso haja mais de 1 argumento, faz um ciclo para executar varias vezes o comando*/
            list.insert_0(arg1);
        }
        else if(!command.compare("insert_end")){
            while(ss>>arg1) /* caso haja mais de 1 argumento, faz um ciclo para executar varias vezes o comando*/
            list.insert_end(arg1);
        }
        else if(!command.compare("dim"))
            list.dim();
        else if(!list.isEmpty()){/* como os comandos a baixo desta condicao sao os unicos que precisas de que haja elementos, mete-se a condição neste nivel*/
            if(!command.compare("print_0"))
                list.print_0();
            else if(!command.compare("print_end"))
                list.print_end();
            else if(!command.compare("print"))
                list.print();
            else if(!command.compare("delete_0"))
                list.delete_0();
            else if(!command.compare("delete_end"))
                list.delete_end();
            else if(!command.compare("clear"))
                list.clear();
            else if(!command.compare("find")){
                ss >> arg1;//vai buscar o argumento a usar
                list.find(arg1);
                }
            else if(!command.compare("find_max"))
                list.find_max();
            else if(!command.compare("delete_pos")){
                ss >> arg1;//vai buscar o argumento a usar
                if(arg1>list.getn()||arg1<0)//Verifica-se se a posicao é valida
                    cout << "Comando " << command << ": Posicao invalida!\n";
                else
                    list.delete_pos(arg1);
                }
            else if(!command.compare("invert_range")){
                ss >> arg1 >> arg2;//vai buscar os argumentos a usar
                if(arg1>list.getn()||arg2>list.getn()||arg1>arg2||arg1<0)//Verifica-se se a posicao é valida
                    cout << "Comando " << command << ": Posicao invalida!\n";
                else
                list.invert_range(arg1,arg2);
                }
            }
            else//caso a lista esteja vazia, reporta-o
                cout << "Comando " << command << ": Lista vazia!\n";
        ss.clear();//Limpa a
        ss.str("");//stringstream
    }
}

   return 0;
}

// EOF

